;prgm:PROG
;
;"1:XXXXXXXX" = Protect
;"2:XXXXXXXX" = Unprotect
;"3:XXXXXXXX" = Squish
;"4:XXXXXXXX" = Unsquish
;
;
.NOLIST
#include "ti83asm.inc"
.LIST
.org progstart

length		equ	Statvars+00
ProgLength	equ	Statvars+01
;		equ	Statvars+02
WriteCounter	equ	Statvars+03
;		equ	Statvars+04
ReadCounter	equ	Statvars+05
;		equ	Statvars+06


;	Code from 'ZASMLOAD' for detecting stringinput
;
;   input : 'Ans' contanis a string with the command
;
;
;
 bcall(_zeroop1)
 ld a,tans
 ld (op1+1),a
 bcall(_findsym)
 jp c,_errundefined  ; error if not there
;
;   de = ptr to data
;
 and $1F
 cp Strngobj
 jp nz,_ERRDATATYPE
 ex de,hl

 ld a,(hl)		; This code checks the length of the string
 ld (length),a
 add a,255-10		; 8=maximum length
 jp c,_ERRDOMAIN

 inc hl
 inc hl
 ld a,(hl)
 ex de,hl		; de = program adress after length bytes
 cp $31
 jp z,PROTECT
 cp $32
 jp z,UNPROTECT
 cp $33
 jp z,SQUISH
 cp $34
 jp z,UNSQUISH
 jp _errsyntax

PROTECT:
 call FINDPROG
 ld a,ProtProgobj
 ld (hl),a
 ret
UNPROTECT:
 call FINDPROG
 ld a,Progobj
 ld (hl),a
 ret
SQUISH:
 call FINDPROG
;
;	Following code is from 'SQUISH'
;
    ex      de,hl
    push    hl               ; SAVE START
    call    _ldhlind         ; HL = SIZE
    LD      (OP5+2),HL
    ex      de,hl
    POP     HL
    PUSH    HL
    ADD     HL,DE            ;
    INC     HL               ; NEEDS TO BE AN 'END' TOKEN
    LD      A,(HL)
    CP      TEND             ; WELL ?
    JP      NZ,_ERRSYNTAX    ; NOT
;
    LD      BC,-7            ;
    ADD     HL,BC            ; (HL) MUST BE END TOKEN
    LD      A,(HL)
    CP      TEND             ; IS IT ?
    JP      NZ,_ERRSYNTAX     ; NO
;
;   WE HAVE VALID SET UP SO FAR
;
    POP     HL               ; START AGAIN
    INC     HL
    INC     HL               ; 1ST BYTE OF CODE
    LD      BC,0             ; BYTE COUNT
LOOP:
    LD      A,(HL)           ;
    INC     HL               ;
    CP      TENTER           ; EOL ?
    JR      Z,LOOP         ; YES
;
    CP      TEND             ; END OF SOURCE ?
    JR      Z,END_SOURCE   ; YES
;
    CALL    IS_NIB           ;
    LD      A,(HL)
    INC     HL
    CALL    IS_NIB           ;
;
;   IF RET THEN HAVE VALID BYTE
;
    INC     BC               ; INCR # BYTES
    JP      LOOP
;
;   BC = # BYTES OF Z80 CODE
;
END_SOURCE:
    PUSH    BC
    INC     HL               ; (HL) = MSN OF 2 BYTE RAM SIZE IN HEX
;
    LD      A,(HL)
    INC     HL
    CALL    IS_NIB           ;
    LD      D,A
    LD      A,(HL)
    INC     HL
    CALL    IS_NIB           ;
    LD      E,A              ; DE = MSB OF RAM SIZE IN DEC
    CALL    ASCII_TO_HEX     ; ACC = MSB OF RAM SIZE IN HEX
    PUSH    AF               ; SAVE
    LD      A,(HL)
    INC     HL
    CALL    IS_NIB           ;
    LD      D,A
    LD      A,(HL)
    CALL    IS_NIB           ;
    LD      E,A              ; DE = LSB OF RAM SIZE IN DEC
    CALL    ASCII_TO_HEX     ; ACC = LSB OF RAM SIZE IN HEX
    POP     HL
    OR      H                ; ADDITIOAN RAM MUST BE 0
    JP      NZ,_ERRINVALID
;
    POP     HL               ; HL # BYTES IN PROG AFTER CONVERSION
    LD      (OP5),HL         ; SAVE
;
;
;   WRITE Z80 CODE TO MEM
;
    CALL    _CHKFINDSYM      ; LOOK UP AGAIN
    PUSH    DE               ; SAVE PTR TO PROG
    PUSH    HL               ; SAVE PTR TO PROG SYM ENTRY
    EX      DE,HL
    INC     HL
    INC     HL               ; 1ST BYTE OF CODE
    PUSH    HL
    POP     DE               ; SET OUTPUT ADDRESS BACK INTO PROG
    PUSH    DE
LOOPW:
    LD      A,(HL)           ;
    INC     HL               ;
    CP      TENTER           ; EOL ?
    JR      Z,LOOPW        ; YES
;
    CP      TEND             ; END OF SOURCE ?
    JR      Z,END_SOURCEW  ; YES
;
    CALL    IS_NIB           ;
    LD      D,A              ; MSN OF BYTE
    LD      A,(HL)
    INC     HL
    CALL    IS_NIB           ;
;
;   IF RET THEN HAVE VALID BYTE
;
    LD      E,A              ; DE = BYTE AS 2 DEC DIGITS 0-15
    CALL    ASCII_TO_HEX     ; ACC = BYTE OF Z80 SOURCE
    POP     DE
    LD      (DE),A           ; WRITE IT
    INC     DE
    PUSH    DE
    JP      LOOPW
;
;   DE = ADDRESS TO START DELETE AT
;
;   # BYTES TO DELETE = (OP5+2,3)-(OP5,+1)
;
;
END_SOURCEW:

    LD      HL,(OP5+2)
    LD      DE,(OP5)
    OR      A
    SBC     HL,DE            ; HL = # BYTES TO DELETE
    EX      DE,HL            ; DE = # BYTES TO DELETE
    POP     HL               ; 1ST BYTE TO DELETE
    CALL    _DELMEM          ; DELETE OLD PARTS OF PROG
;
    POP     HL               ; PTR TO PROG SYM
    LD      (HL),ProtProgobj ; MAKE PROTECTED
;
    POP     HL               ; PTR TO TOP OF PROG, SIZE
    LD      DE,(OP5)         ; NEW SIZE
    LD      (HL),E
    INC     HL
    LD      (HL),D           ; WRITE NEW SIZE OF PROG
;
    RET
;
;
ASCII_TO_HEX:
    PUSH    HL               ; SAVE
    LD      A,D              ; MSN
    CALL    _SHLACC           ;
    ADD     A,E                ; ACC = BYTE
    POP     HL
    RET
;
IS_NIB:
    CP      T0
    JP      C,_ERRSYNTAX      ; NOT # OR LETTER
    CP      T9+1             ; 0 - 9 ?
    JR      NC,NOTNUM
;
    SUB     T0               ; MAKE DEC 0 - 9
    RET
;
NOTNUM:
    CP      TA
    JP      C,_ERRSYNTAX      ; NOT A-F
;
    CP      TG
    JP      NC,_ERRSYNTAX        ; NOT A-F
;
    SUB      TA-10           ; 10 - 15
    RET

UNSQUISH:
; what unsquish must do:
; 1: allocate memory
; 2: convert each byte in two and change its position
; 3: fill end syntax


; 1: allocate memory:
; new progran length = [old program length]*2+9

 call FINDPROG

 ex de,hl		; hl=program adress
 ld e,(hl)
 inc hl
 ld d,(hl)		; de=program length
 inc hl
 ld (WriteCounter),hl
 ex de,hl		; hl=program length
 ld (ProgLength),hl
 ld de,9
 add hl,de		; hl=new program length
 push hl
 bcall(_EnoughMem)
 jp c,_ErrMemory
 ld hl,(WriteCounter)
 ex de,hl		; hl=program length and de=insertion adress
 bcall(_InsertMem)
 pop hl			; hl=program length+9
 push de		; de=program adress
 ex de,hl		; de=program length+9
 ld hl,(ProgLength)	; hl=program length
 add hl,de
 pop de			; de=program adress
 ex de,hl
 dec hl
 ld (hl),d		; load new length
 dec hl
 ld (hl),e		; load new length


; 2: convert each byte in two and change its position:

 ld hl,(WriteCounter)
 ex de,hl
 ld hl,(ProgLength)
 add hl,de
 ld de,9
 add hl,de
 ld (ReadCounter),hl

 ld hl,(ProgLength)
UNSQUISH_LOOP:
 push hl
 ld hl,(ReadCounter)
 ld a,(hl)
 inc hl
 ld (ReadCounter),hl	; load new counter
 call CONVERT_BYTE	; convert a into de
 ld hl,(WriteCounter)
 ld (hl),d		; write 1st converted byte
 inc hl
 ld (hl),e		; write 2nd converted byte
 inc hl
 ld (WriteCounter),hl	; load new counter
 pop hl
 ld de,0
 dec hl
 bcall(_cphlde)
 jr nz,UNSQUISH_LOOP

 ld de,END_SYNTAX
 ld hl,(WriteCounter)
 ex de,hl
 ld bc,9
 ldir			; load the end:0000:end syntax
 ret








CONVERT_BYTE:
; changes one byte into a two-byte hexadecimal number
; input:
; a: byte to convert
; output:
; de: converted bytes

; $0	%0000
; $1	%0001
; $2	%0010
; $3	%0011
; $4	%0100
; $5	%0101
; $6	%0110
; $7	%0111
; $8	%1000
; $9	%1001
; $A	%1010
; $B	%1011
; $C	%1100
; $D	%1101
; $E	%1110
; $F	%1111
 push af
 and %11110000		; mask out the first part of the byte
 ld b,4
ROTATE_LOOP:
 rra
 djnz ROTATE_LOOP
 call CONVBYTE
 ld d,a			; return 1st byte
 pop af
 and %00001111		; mask out the second part of the byte
 call CONVBYTE
 ld e,a			; return 2nd byte
 ret



CONVBYTE:		; convert a hexadecimal digit into an ascii character
 add a,255-9
 jr c,ABCDEF
 ld b,255-$39		; ascii #9
 sub b			; a is now an ascii number
 ret
ABCDEF:
 ld b,'A'
 and a
 jr z,ABCDEF_DEFINED
 inc b
 cp 1
 jr z,ABCDEF_DEFINED
 inc b
 cp 2
 jr z,ABCDEF_DEFINED
 inc b
 cp 3
 jr z,ABCDEF_DEFINED
 inc b
 cp 4
 jr z,ABCDEF_DEFINED
 inc b			; b='F'
ABCDEF_DEFINED:
 ld a,b
 ret





END_SYNTAX:
 .db tEnter,tEnd,tEnter,"0000",tEnter,tEnd

FINDPROG:
 ld hl,op1
 ld (hl),Progobj
 inc hl
 ld a,(length)           ; get size of name
 dec a
 dec a
 ld c,a
 ld b,0
 inc de
 inc de               ; (de) = 1st byte of prog name
 ex de,hl
 ldir                     ; name to op1
;
;   op1 = name of prog to protect
;
 call _chkfindsym      ; look up
 jp c,_errundefined
 ret
.end
END

;_ERRDATATYPE
;_ERRDOMAIN
;_ERRD_OP1NOT_R
;_ERREND
;_ERRNONREAL
;_ERROVERFLOW
; 
;_ErrorEP
; 
;_errBadGuess
;_errIterations
;_errSingularMat
;_errTolTooSmall
; 
;_ERRDIMENSION
;_ERRD_OP1NOTPOS
;_ERRD_OP1_0
;_ERRINVALID
;_ERRNON_REAL
;_ERRSTATPLOT
; 
;_errDimMismatch
;_errLinkXmit
;_errStat
; 
;_ERRBREAK
;_ERRDIVBY0
;_ERRD_OP1NOTPOSINT
;_ERRD_OP1_LE_0
;_ERRMEMORY
;_ERRNOTENOUGHMEM
;_ERRUNDEFINED
; 
;_errArgument
;_errIncrement
;_errSignChange
;_errSyntax